#region Copyright Syncfusion Inc. 2001 -2004
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//  Copyright Syncfusion Inc. All rights reserved. Use of this code is subject to the terms of our 
//  license. A copy of the current license can be obtained at any time by e-mailing licensing@syncfusion.com. 
//  Re-distribution in any form is strictly prohibited. Any infringement will be prosecuted under applicable laws. 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
#endregion 
 
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Reflection;
using System.Windows.Forms;
using System.IO;
using System.Data;
using System.Runtime.Serialization.Formatters.Soap;

namespace Syncfusion.Windows.Forms.Diagram.Samples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.ToolBarButton toolBarButtonSelect;
		private System.Windows.Forms.ToolBarButton toolBarButtonAddSymbol;
		private Syncfusion.Windows.Forms.Diagram.SymbolPalette symPalette;
		private Syncfusion.Windows.Forms.Diagram.SymbolModel customSymbolMdl;
		private Syncfusion.Windows.Forms.Diagram.InsertSymbolTool insSymbolTool;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.StatusBarPanel clickCountPanel;
		private Syncfusion.Windows.Forms.Diagram.Controls.PropertyEditor propertyEditor1;
		private Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagram1;
		private System.Windows.Forms.ToolBarButton toolBarButtonClone;
		private Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupBar paletteGroupBar1;
		private Syncfusion.Windows.Forms.Tools.GroupBarItem CustomSymbol;
		private Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView paletteGroupView1;
		
		private System.ComponentModel.IContainer components;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// Load up the symbol palette from the resource file
			//
			this.LoadPalette();

			//
			// Get a reference to the custom symbol model in the symbol palette
			if (this.symPalette != null)
			{
				this.customSymbolMdl = this.symPalette.Nodes.GetNodeByName("Custom Symbol") as SymbolModel;
			}

			//
			// Create and register an InsertSymbolTool for the custom symbol
			//
			this.insSymbolTool = new InsertSymbolTool("InsertCustomSymbol");
			this.diagram1.Controller.RegisterTool(this.insSymbolTool);
		}

		public void LoadPalette()
		{
			Assembly assembly = typeof(MainForm).Assembly;
			System.IO.Stream strmRes = assembly.GetManifestResourceStream("Syncfusion.Windows.Forms.Diagram.Samples.CustomSymbol.edp");
			if (strmRes != null)
			{
				SoapFormatter formatter = new SoapFormatter();
				formatter.AssemblyFormat = System.Runtime.Serialization.Formatters.FormatterAssemblyStyle.Simple;
				try
				{
					System.AppDomain.CurrentDomain.AssemblyResolve += new ResolveEventHandler(DiagramAssembly.AssemblyResolver);
					this.symPalette = (SymbolPalette) formatter.Deserialize(strmRes);
				}
				catch (Exception ex)
				{
					MessageBox.Show(ex.Message);
					this.symPalette = null;
				}
				finally
				{
					strmRes.Close();
					System.AppDomain.CurrentDomain.AssemblyResolve -= new ResolveEventHandler(DiagramAssembly.AssemblyResolver);
				}
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.toolBar1 = new System.Windows.Forms.ToolBar();
			this.toolBarButtonSelect = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonAddSymbol = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonClone = new System.Windows.Forms.ToolBarButton();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.clickCountPanel = new System.Windows.Forms.StatusBarPanel();
			this.propertyEditor1 = new Syncfusion.Windows.Forms.Diagram.Controls.PropertyEditor();
			this.diagram1 = new Syncfusion.Windows.Forms.Diagram.Controls.Diagram();
			this.paletteGroupBar1 = new Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupBar();
			this.paletteGroupView1 = new Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView();
			this.CustomSymbol = new Syncfusion.Windows.Forms.Tools.GroupBarItem();
			((System.ComponentModel.ISupportInitialize)(this.clickCountPanel)).BeginInit();
			this.paletteGroupBar1.SuspendLayout();
			this.SuspendLayout();
			// 
			// toolBar1
			// 
			this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.toolBarButtonSelect,
																						this.toolBarButtonAddSymbol,
																						this.toolBarButtonClone});
			this.toolBar1.DropDownArrows = true;
			this.toolBar1.ImageList = this.imageList1;
			this.toolBar1.Location = new System.Drawing.Point(0, 0);
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.ShowToolTips = true;
			this.toolBar1.Size = new System.Drawing.Size(672, 28);
			this.toolBar1.TabIndex = 0;
			this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
			// 
			// toolBarButtonSelect
			// 
			this.toolBarButtonSelect.ImageIndex = 0;
			this.toolBarButtonSelect.ToolTipText = "Select";
			// 
			// toolBarButtonAddSymbol
			// 
			this.toolBarButtonAddSymbol.ImageIndex = 1;
			this.toolBarButtonAddSymbol.ToolTipText = "Add Symbol";
			// 
			// toolBarButtonClone
			// 
			this.toolBarButtonClone.ImageIndex = 2;
			this.toolBarButtonClone.ToolTipText = "Clone";
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Fuchsia;
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 480);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						  this.clickCountPanel});
			this.statusBar1.ShowPanels = true;
			this.statusBar1.Size = new System.Drawing.Size(672, 22);
			this.statusBar1.TabIndex = 2;
			// 
			// clickCountPanel
			// 
			this.clickCountPanel.MinWidth = 300;
			this.clickCountPanel.Width = 300;
			// 
			// propertyEditor1
			// 
			this.propertyEditor1.Diagram = this.diagram1;
			this.propertyEditor1.Dock = System.Windows.Forms.DockStyle.Right;
			this.propertyEditor1.Location = new System.Drawing.Point(512, 28);
			this.propertyEditor1.Name = "propertyEditor1";
			this.propertyEditor1.Size = new System.Drawing.Size(160, 452);
			this.propertyEditor1.TabIndex = 5;
			// 
			// diagram1
			// 
			this.diagram1.AllowDrop = true;
			// 
			// diagram1.Controller
			// 
			this.diagram1.Controller.MaxHistory = 256;
			this.diagram1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.diagram1.HScroll = true;
			this.diagram1.LayoutManager = null;
			this.diagram1.Location = new System.Drawing.Point(0, 28);
			// 
			// diagram1.Model
			// 
			this.diagram1.Model.BackgroundStyle.Color = System.Drawing.Color.White;
			this.diagram1.Model.BackgroundStyle.GradientAngle = 90F;
			this.diagram1.Model.BackgroundStyle.GradientBounds = ((System.Drawing.RectangleF)(resources.GetObject("diagram1.Model.BackgroundStyle.GradientBounds")));
			this.diagram1.Model.BackgroundStyle.GradientStartColor = System.Drawing.Color.White;
			this.diagram1.Model.BackgroundStyle.Properties = this.diagram1.Model;
			this.diagram1.Model.BackgroundStyle.Texture = null;
			this.diagram1.Model.BackgroundStyle.TextureWrapMode = System.Drawing.Drawing2D.WrapMode.Tile;
			this.diagram1.Model.BackgroundStyle.Type = Syncfusion.Windows.Forms.Diagram.BackgroundStyle.BackgroundType.Solid;
			this.diagram1.Model.BoundaryConstraintsEnabled = true;
			this.diagram1.Model.FillStyle.AlphaFactor = 255;
			this.diagram1.Model.FillStyle.Color = System.Drawing.Color.LightGray;
			this.diagram1.Model.FillStyle.GradientAngle = 90F;
			this.diagram1.Model.FillStyle.GradientBounds = ((System.Drawing.RectangleF)(resources.GetObject("diagram1.Model.FillStyle.GradientBounds")));
			this.diagram1.Model.FillStyle.GradientStartColor = System.Drawing.Color.LightGray;
			this.diagram1.Model.FillStyle.Properties = this.diagram1.Model;
			this.diagram1.Model.FillStyle.Texture = null;
			this.diagram1.Model.FillStyle.TextureWrapMode = System.Drawing.Drawing2D.WrapMode.Tile;
			this.diagram1.Model.FillStyle.Type = Syncfusion.Windows.Forms.Diagram.FillStyle.FillType.Solid;
			this.diagram1.Model.Height = 1056F;
			this.diagram1.Model.LineStyle.DashCap = System.Drawing.Drawing2D.DashCap.Flat;
			this.diagram1.Model.LineStyle.DashOffset = 0F;
			this.diagram1.Model.LineStyle.DashStyle = System.Drawing.Drawing2D.DashStyle.Solid;
			this.diagram1.Model.LineStyle.EndCap = System.Drawing.Drawing2D.LineCap.Flat;
			this.diagram1.Model.LineStyle.LineColor = System.Drawing.Color.Black;
			this.diagram1.Model.LineStyle.LineJoin = System.Drawing.Drawing2D.LineJoin.Bevel;
			this.diagram1.Model.LineStyle.LineWidth = 2F;
			this.diagram1.Model.LineStyle.MiterLimit = 10F;
			this.diagram1.Model.LineStyle.Properties = this.diagram1.Model;
			this.diagram1.Model.MeasurementScale = 1F;
			this.diagram1.Model.MeasurementUnits = System.Drawing.GraphicsUnit.Pixel;
			this.diagram1.Model.Name = "Model";
			this.diagram1.Model.RenderingStyle.Properties = this.diagram1.Model;
			this.diagram1.Model.RenderingStyle.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.Default;
			this.diagram1.Model.ShadowStyle.AlphaFactor = 128;
			this.diagram1.Model.ShadowStyle.Color = System.Drawing.Color.LightGray;
			this.diagram1.Model.ShadowStyle.OffsetX = 6F;
			this.diagram1.Model.ShadowStyle.OffsetY = 6F;
			this.diagram1.Model.ShadowStyle.Properties = this.diagram1.Model;
			this.diagram1.Model.ShadowStyle.Visible = false;
			this.diagram1.Model.Width = 816F;
			this.diagram1.Name = "diagram1";
			this.diagram1.NudgeIncrement = 1F;
			this.diagram1.ScrollGranularity = 0.5F;
			this.diagram1.Size = new System.Drawing.Size(512, 452);
			this.diagram1.SmartSizeBox = false;
			this.diagram1.TabIndex = 6;
			this.diagram1.Text = "diagram1";
			// 
			// diagram1.View
			// 
			this.diagram1.View.BackgroundColor = System.Drawing.Color.DarkGray;
			this.diagram1.View.Grid.Color = System.Drawing.Color.Black;
			this.diagram1.View.Grid.DashOffset = 4F;
			this.diagram1.View.Grid.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;
			this.diagram1.View.Grid.GridStyle = Syncfusion.Windows.Forms.Diagram.GridStyle.Point;
			this.diagram1.View.Grid.HorizontalSpacing = 10F;
			this.diagram1.View.Grid.SnapToGrid = true;
			this.diagram1.View.Grid.VerticalSpacing = 10F;
			this.diagram1.View.Grid.Visible = true;
			this.diagram1.View.HandleAnchorColor = System.Drawing.Color.LightGray;
			this.diagram1.View.HandleColor = System.Drawing.Color.White;
			this.diagram1.View.HandleDisabledColor = System.Drawing.Color.Black;
			this.diagram1.View.HandleSize = 6;
			this.diagram1.View.HorizontalRuler.Visible = false;
			this.diagram1.View.MouseTrackingEnabled = true;
			this.diagram1.View.PasteOffsetX = 10;
			this.diagram1.View.PasteOffsetY = 10;
			this.diagram1.View.RulerFillColor = System.Drawing.Color.LightGray;
			this.diagram1.View.RulerLineColor = System.Drawing.Color.Black;
			this.diagram1.View.RulerSize = 16;
			this.diagram1.View.RulerUnits = Syncfusion.Windows.Forms.Diagram.MeasurementsUnit.Inches;
			this.diagram1.View.ShowPageBounds = true;
			this.diagram1.View.VerticalRuler.Visible = false;
			this.diagram1.VScroll = true;
			// 
			// paletteGroupBar1
			// 
			this.paletteGroupBar1.AllowDrop = true;
			this.paletteGroupBar1.Controls.Add(this.paletteGroupView1);
			this.paletteGroupBar1.Dock = System.Windows.Forms.DockStyle.Left;
			this.paletteGroupBar1.EditMode = false;
			this.paletteGroupBar1.GroupBarItems.AddRange(new Syncfusion.Windows.Forms.Tools.GroupBarItem[] {
																											   this.CustomSymbol});
			this.paletteGroupBar1.Location = new System.Drawing.Point(0, 28);
			this.paletteGroupBar1.Name = "paletteGroupBar1";
			this.paletteGroupBar1.SelectedItem = 0;
			this.paletteGroupBar1.Size = new System.Drawing.Size(168, 452);
			this.paletteGroupBar1.TabIndex = 7;
			this.paletteGroupBar1.Text = "paletteGroupBar1";
			// 
			// paletteGroupView1
			// 
			this.paletteGroupView1.EditMode = false;
			this.paletteGroupView1.Location = new System.Drawing.Point(2, 24);
			this.paletteGroupView1.Name = "paletteGroupView1";
			this.paletteGroupView1.Size = new System.Drawing.Size(164, 426);
			this.paletteGroupView1.TabIndex = 0;
			this.paletteGroupView1.Text = "paletteGroupView1";
			this.paletteGroupView1.LoadPalette(typeof(Syncfusion.Windows.Forms.Diagram.Samples.MainForm).Assembly, "Syncfusion.Windows.Forms.Diagram.Samples.MainForm", "paletteGroupView1.Palette");
			// 
			// CustomSymbol
			// 
			this.CustomSymbol.Client = this.paletteGroupView1;
			this.CustomSymbol.Text = "GroupBarItem0";
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(672, 502);
			this.Controls.Add(this.paletteGroupBar1);
			this.Controls.Add(this.diagram1);
			this.Controls.Add(this.propertyEditor1);
			this.Controls.Add(this.statusBar1);
			this.Controls.Add(this.toolBar1);
			this.Name = "MainForm";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show;
			this.Text = "Custom Symbol Sample";
			this.Load += new System.EventHandler(this.MainForm_Load);
			((System.ComponentModel.ISupportInitialize)(this.clickCountPanel)).EndInit();
			this.paletteGroupBar1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if (e.Button == this.toolBarButtonAddSymbol)
			{
				if (this.customSymbolMdl != null)
				{
					Symbol sym = this.customSymbolMdl.CreateSymbol();
					if (sym != null)
					{
						this.insSymbolTool.Symbol = sym;
						this.diagram1.ActivateTool("InsertCustomSymbol");
					}
				}
			}
			else if (e.Button == this.toolBarButtonClone)
			{
				if (this.diagram1.SelectionList.Count > 0)
				{
					Symbol selectedSymbol = this.diagram1.SelectionList[0] as Symbol;
					if (selectedSymbol != null)
					{
						Symbol symbolClone = (Symbol) selectedSymbol.Clone();
						symbolClone.Translate(5,5);
						this.diagram1.Model.AppendChild(symbolClone);
						this.diagram1.Refresh();
					}
				}
			}
			else
			{
				this.diagram1.ActivateTool("SelectTool");
			}
		}

		private void diagram1_Controller_SelectionChanged(object sender, Syncfusion.Windows.Forms.Diagram.NodeCollection.EventArgs evtArgs)
		{
			int clickCount = 0;

			foreach (INode curNode in this.diagram1.Controller.SelectionList)
			{
				MySymbol curSym = curNode as MySymbol;
				if (curSym != null)
				{
					clickCount += curSym.ClickCount;
				}
			}

			this.clickCountPanel.Text = "Click count for currently selected symbols is " + clickCount.ToString();
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
		
		}


	}
}
