#region Copyright Syncfusion Inc. 2001 -2004
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//  Copyright Syncfusion Inc. All rights reserved. Use of this code is subject to the terms of our 
//  license. A copy of the current license can be obtained at any time by e-mailing licensing@syncfusion.com. 
//  Re-distribution in any form is strictly prohibited. Any infringement will be prosecuted under applicable laws. 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
#endregion 
 
using System;
using System.ComponentModel;
using System.Globalization;
using System.Runtime.Serialization;
using System.Windows.Forms;
using System.Diagnostics;

using Syncfusion.Windows.Forms.Diagram;

namespace Syncfusion.Windows.Forms.Diagram.Samples
{
	/// <summary>
	/// Summary description for MySymbol.
	/// </summary>
	[
	Serializable(),
	TypeConverter(typeof(MySymbolConverter))
	]
	public class MySymbol : Symbol
	{
		/// <summary>
		/// Default constructor.
		/// </summary>
		public MySymbol()
		{
		}

		/// <summary>
		/// Copy constructor.
		/// </summary>
		/// <param name="src"></param>
		public MySymbol(MySymbol src) : base(src)
		{
		}

		/// <summary>
		/// Serialization constructor for the MySymbol class.
		/// </summary>
		/// <param name="info">Serialization state information</param>
		/// <param name="context">Streaming context information</param>
		protected MySymbol(SerializationInfo info, StreamingContext context) : base(info, context)
		{
			// The Serialization constructor is invoked during deserialization or during a drag & drop operation.
			// If the MySymbol type has serializable members, then initialize them with the serialized data 
			// obtained from the SerializationInfo param
		}

		// Override SymbolBase.GetObjectData() and populate the SerializationInfo param 
		// with the data (if any) that belongs to the MySymbol type . This data will be 
		// serialized as a part of the Symbol object.
		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}

		/// <summary>
		/// Creates a new object that is a copy of the current instance.
		/// </summary>
		/// <returns>Copy of the object this method is invoked against</returns>
		public override object Clone()
		{
			return new MySymbol(this);
		}
string clickcount = "Click Count";
		public override void SetDefaultPropertyValues()
		{
			base.SetDefaultPropertyValues();
			this.SetPropertyValue(clickcount, 0);
		}

		public int ClickCount
		{
			get
			{
				object value = this.GetPropertyValue(clickcount);
				if (value != null)
				{
					return (int) value;
				}
				return 0;
			}
		}

		protected override void OnClick(NodeMouseEventArgs evtArgs)
		{
			int newClickCount = this.ClickCount + 1;
			this.SetPropertyValue(clickcount, newClickCount);
			base.OnClick(evtArgs);
		}
	}

	public class MySymbolConverter : System.ComponentModel.TypeConverter
	{
		public override object ConvertTo(ITypeDescriptorContext context, CultureInfo culture, object value, Type destinationType) 
		{
			return base.ConvertTo(context, culture, value, destinationType);
		}

		public override bool GetPropertiesSupported(ITypeDescriptorContext context)
		{
			return true;
		}

		public override PropertyDescriptorCollection GetProperties(ITypeDescriptorContext context, object value, Attribute[] attributes)
		{
			System.Attribute[] attrs = new System.Attribute[]
			{
				new System.ComponentModel.BrowsableAttribute(true)
			};
#if true
			// This code returns only the specified properties. It can be used to filter out
			// properties that you do not wish to expose to in property grid.
			PropertyDescriptor[] props = new PropertyDescriptor[4];


			props[0] = TypeDescriptor.CreateProperty(typeof(MySymbol), "Name", typeof(string), attrs);
			props[1] = TypeDescriptor.CreateProperty(typeof(MySymbol), "ClickCount", typeof(int), attrs);
			
			props[2] = TypeDescriptor.CreateProperty(typeof(MySymbol), "Labels", typeof(LabelCollection), attrs);
			props[3] = TypeDescriptor.CreateProperty(typeof(MySymbol), "DefaultLabelName", typeof(string), attrs);
			return new PropertyDescriptorCollection(props);
#else
			// This code returns all browsable properties
			return TypeDescriptor.GetProperties(value, attrs);
#endif
		}
	}
}
